"use strict";

module.exports = function () {
  "use strict";
  /*
   * Generated by PEG.js 0.9.0.
   *
   * http://pegjs.org/
   */

  function peg$subclass(child, parent) {
    function ctor() {
      this.constructor = child;
    }

    ctor.prototype = parent.prototype;
    child.prototype = new ctor();
  }

  function peg$SyntaxError(message, expected, found, location) {
    this.message = message;
    this.expected = expected;
    this.found = found;
    this.location = location;
    this.name = "SyntaxError";

    if (typeof Error.captureStackTrace === "function") {
      Error.captureStackTrace(this, peg$SyntaxError);
    }
  }

  peg$subclass(peg$SyntaxError, Error);

  function peg$parse(input) {
    var options = arguments.length > 1 ? arguments[1] : {},
        parser = this,
        peg$FAILED = {},
        peg$startRuleFunctions = {
      start: peg$parsestart,
      Literal: peg$parseLiteral
    },
        peg$startRuleFunction = peg$parsestart,
        peg$c0 = function (query, trailing) {
      if (trailing.type === 'cursor') {
        return { ...trailing,
          suggestionTypes: ['conjunction']
        };
      }

      if (query !== null) return query;
      return nodeTypes.function.buildNode('is', '*', '*');
    },
        peg$c1 = function (head, query) {
      return query;
    },
        peg$c2 = function (head, tail) {
      const nodes = [head, ...tail];
      const cursor = parseCursor && nodes.find(node => node.type === 'cursor');
      if (cursor) return cursor;
      return buildFunctionNode('or', nodes);
    },
        peg$c3 = function (head, tail) {
      const nodes = [head, ...tail];
      const cursor = parseCursor && nodes.find(node => node.type === 'cursor');
      if (cursor) return cursor;
      return buildFunctionNode('and', nodes);
    },
        peg$c4 = function (query) {
      if (query.type === 'cursor') return query;
      return buildFunctionNode('not', [query]);
    },
        peg$c5 = "(",
        peg$c6 = {
      type: "literal",
      value: "(",
      description: "\"(\""
    },
        peg$c7 = ")",
        peg$c8 = {
      type: "literal",
      value: ")",
      description: "\")\""
    },
        peg$c9 = function (query, trailing) {
      if (trailing.type === 'cursor') {
        return { ...trailing,
          suggestionTypes: ['conjunction']
        };
      }

      return query;
    },
        peg$c10 = ":",
        peg$c11 = {
      type: "literal",
      value: ":",
      description: "\":\""
    },
        peg$c12 = "{",
        peg$c13 = {
      type: "literal",
      value: "{",
      description: "\"{\""
    },
        peg$c14 = "}",
        peg$c15 = {
      type: "literal",
      value: "}",
      description: "\"}\""
    },
        peg$c16 = function (field, query, trailing) {
      if (query.type === 'cursor') {
        return { ...query,
          nestedPath: query.nestedPath ? `${field.value}.${query.nestedPath}` : field.value
        };
      }

      ;

      if (trailing.type === 'cursor') {
        return { ...trailing,
          suggestionTypes: ['conjunction']
        };
      }

      return buildFunctionNode('nested', [field, query]);
    },
        peg$c17 = {
      type: "other",
      description: "fieldName"
    },
        peg$c18 = function (field, operator, value) {
      if (value.type === 'cursor') {
        return { ...value,
          suggestionTypes: ['conjunction']
        };
      }

      const range = buildNamedArgNode(operator, value);
      return buildFunctionNode('range', [field, range]);
    },
        peg$c19 = function (field, partial) {
      if (partial.type === 'cursor') {
        return { ...partial,
          fieldName: field.value,
          suggestionTypes: ['value', 'conjunction']
        };
      }

      return partial(field);
    },
        peg$c20 = function (partial) {
      if (partial.type === 'cursor') {
        const fieldName = `${partial.prefix}${partial.suffix}`.trim();
        return { ...partial,
          fieldName,
          suggestionTypes: ['field', 'operator', 'conjunction']
        };
      }

      const field = buildLiteralNode(null);
      return partial(field);
    },
        peg$c21 = function (partial, trailing) {
      if (trailing.type === 'cursor') {
        return { ...trailing,
          suggestionTypes: ['conjunction']
        };
      }

      return partial;
    },
        peg$c22 = function (head, partial) {
      return partial;
    },
        peg$c23 = function (head, tail) {
      const nodes = [head, ...tail];
      const cursor = parseCursor && nodes.find(node => node.type === 'cursor');

      if (cursor) {
        return { ...cursor,
          suggestionTypes: ['value']
        };
      }

      return field => buildFunctionNode('or', nodes.map(partial => partial(field)));
    },
        peg$c24 = function (head, tail) {
      const nodes = [head, ...tail];
      const cursor = parseCursor && nodes.find(node => node.type === 'cursor');

      if (cursor) {
        return { ...cursor,
          suggestionTypes: ['value']
        };
      }

      return field => buildFunctionNode('and', nodes.map(partial => partial(field)));
    },
        peg$c25 = function (partial) {
      if (partial.type === 'cursor') {
        return { ...list,
          suggestionTypes: ['value']
        };
      }

      return field => buildFunctionNode('not', [partial(field)]);
    },
        peg$c26 = {
      type: "other",
      description: "value"
    },
        peg$c27 = function (value) {
      if (value.type === 'cursor') return value;
      const isPhrase = buildLiteralNode(true);
      return field => buildFunctionNode('is', [field, value, isPhrase]);
    },
        peg$c28 = function (value) {
      if (value.type === 'cursor') return value;

      if (!allowLeadingWildcards && value.type === 'wildcard' && nodeTypes.wildcard.hasLeadingWildcard(value)) {
        error('Leading wildcards are disabled. See query:allowLeadingWildcards in Advanced Settings.');
      }

      const isPhrase = buildLiteralNode(false);
      return field => buildFunctionNode('is', [field, value, isPhrase]);
    },
        peg$c29 = {
      type: "other",
      description: "OR"
    },
        peg$c30 = "or",
        peg$c31 = {
      type: "literal",
      value: "or",
      description: "\"or\""
    },
        peg$c32 = {
      type: "other",
      description: "AND"
    },
        peg$c33 = "and",
        peg$c34 = {
      type: "literal",
      value: "and",
      description: "\"and\""
    },
        peg$c35 = {
      type: "other",
      description: "NOT"
    },
        peg$c36 = "not",
        peg$c37 = {
      type: "literal",
      value: "not",
      description: "\"not\""
    },
        peg$c38 = {
      type: "other",
      description: "literal"
    },
        peg$c39 = function () {
      return parseCursor;
    },
        peg$c40 = "\"",
        peg$c41 = {
      type: "literal",
      value: "\"",
      description: "\"\\\"\""
    },
        peg$c42 = function (prefix, cursor, suffix) {
      const {
        start,
        end
      } = location();
      return {
        type: 'cursor',
        start: start.offset,
        end: end.offset - cursor.length,
        prefix: prefix.join(''),
        suffix: suffix.join(''),
        text: text().replace(cursor, '')
      };
    },
        peg$c43 = function (chars) {
      return buildLiteralNode(chars.join(''));
    },
        peg$c44 = "\\",
        peg$c45 = {
      type: "literal",
      value: "\\",
      description: "\"\\\\\""
    },
        peg$c46 = /^[\\"]/,
        peg$c47 = {
      type: "class",
      value: "[\\\\\"]",
      description: "[\\\\\"]"
    },
        peg$c48 = function (char) {
      return char;
    },
        peg$c49 = /^[^"]/,
        peg$c50 = {
      type: "class",
      value: "[^\"]",
      description: "[^\"]"
    },
        peg$c51 = function (chars) {
      const sequence = chars.join('').trim();
      if (sequence === 'null') return buildLiteralNode(null);
      if (sequence === 'true') return buildLiteralNode(true);
      if (sequence === 'false') return buildLiteralNode(false);
      if (chars.includes(wildcardSymbol)) return buildWildcardNode(sequence);
      return buildLiteralNode(sequence);
    },
        peg$c52 = {
      type: "any",
      description: "any character"
    },
        peg$c53 = "*",
        peg$c54 = {
      type: "literal",
      value: "*",
      description: "\"*\""
    },
        peg$c55 = function () {
      return wildcardSymbol;
    },
        peg$c56 = "\\t",
        peg$c57 = {
      type: "literal",
      value: "\\t",
      description: "\"\\\\t\""
    },
        peg$c58 = function () {
      return '\t';
    },
        peg$c59 = "\\r",
        peg$c60 = {
      type: "literal",
      value: "\\r",
      description: "\"\\\\r\""
    },
        peg$c61 = function () {
      return '\r';
    },
        peg$c62 = "\\n",
        peg$c63 = {
      type: "literal",
      value: "\\n",
      description: "\"\\\\n\""
    },
        peg$c64 = function () {
      return '\n';
    },
        peg$c65 = function (keyword) {
      return keyword;
    },
        peg$c66 = /^[\\():<>"*{}]/,
        peg$c67 = {
      type: "class",
      value: "[\\\\():<>\"*{}]",
      description: "[\\\\():<>\"*{}]"
    },
        peg$c68 = function (sequence) {
      return sequence;
    },
        peg$c69 = "u",
        peg$c70 = {
      type: "literal",
      value: "u",
      description: "\"u\""
    },
        peg$c71 = function (digits) {
      return String.fromCharCode(parseInt(digits, 16));
    },
        peg$c72 = /^[0-9a-f]/i,
        peg$c73 = {
      type: "class",
      value: "[0-9a-f]i",
      description: "[0-9a-f]i"
    },
        peg$c74 = "<=",
        peg$c75 = {
      type: "literal",
      value: "<=",
      description: "\"<=\""
    },
        peg$c76 = function () {
      return 'lte';
    },
        peg$c77 = ">=",
        peg$c78 = {
      type: "literal",
      value: ">=",
      description: "\">=\""
    },
        peg$c79 = function () {
      return 'gte';
    },
        peg$c80 = "<",
        peg$c81 = {
      type: "literal",
      value: "<",
      description: "\"<\""
    },
        peg$c82 = function () {
      return 'lt';
    },
        peg$c83 = ">",
        peg$c84 = {
      type: "literal",
      value: ">",
      description: "\">\""
    },
        peg$c85 = function () {
      return 'gt';
    },
        peg$c86 = {
      type: "other",
      description: "whitespace"
    },
        peg$c87 = /^[ \t\r\n\xA0]/,
        peg$c88 = {
      type: "class",
      value: "[\\ \\t\\r\\n\\u00A0]",
      description: "[\\ \\t\\r\\n\\u00A0]"
    },
        peg$c89 = "@kuery-cursor@",
        peg$c90 = {
      type: "literal",
      value: "@kuery-cursor@",
      description: "\"@kuery-cursor@\""
    },
        peg$c91 = function () {
      return cursorSymbol;
    },
        peg$currPos = 0,
        peg$savedPos = 0,
        peg$posDetailsCache = [{
      line: 1,
      column: 1,
      seenCR: false
    }],
        peg$maxFailPos = 0,
        peg$maxFailExpected = [],
        peg$silentFails = 0,
        peg$resultsCache = {},
        peg$result;

    if ("startRule" in options) {
      if (!(options.startRule in peg$startRuleFunctions)) {
        throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
      }

      peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
    }

    function text() {
      return input.substring(peg$savedPos, peg$currPos);
    }

    function location() {
      return peg$computeLocation(peg$savedPos, peg$currPos);
    }

    function expected(description) {
      throw peg$buildException(null, [{
        type: "other",
        description: description
      }], input.substring(peg$savedPos, peg$currPos), peg$computeLocation(peg$savedPos, peg$currPos));
    }

    function error(message) {
      throw peg$buildException(message, null, input.substring(peg$savedPos, peg$currPos), peg$computeLocation(peg$savedPos, peg$currPos));
    }

    function peg$computePosDetails(pos) {
      var details = peg$posDetailsCache[pos],
          p,
          ch;

      if (details) {
        return details;
      } else {
        p = pos - 1;

        while (!peg$posDetailsCache[p]) {
          p--;
        }

        details = peg$posDetailsCache[p];
        details = {
          line: details.line,
          column: details.column,
          seenCR: details.seenCR
        };

        while (p < pos) {
          ch = input.charAt(p);

          if (ch === "\n") {
            if (!details.seenCR) {
              details.line++;
            }

            details.column = 1;
            details.seenCR = false;
          } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
            details.line++;
            details.column = 1;
            details.seenCR = true;
          } else {
            details.column++;
            details.seenCR = false;
          }

          p++;
        }

        peg$posDetailsCache[pos] = details;
        return details;
      }
    }

    function peg$computeLocation(startPos, endPos) {
      var startPosDetails = peg$computePosDetails(startPos),
          endPosDetails = peg$computePosDetails(endPos);
      return {
        start: {
          offset: startPos,
          line: startPosDetails.line,
          column: startPosDetails.column
        },
        end: {
          offset: endPos,
          line: endPosDetails.line,
          column: endPosDetails.column
        }
      };
    }

    function peg$fail(expected) {
      if (peg$currPos < peg$maxFailPos) {
        return;
      }

      if (peg$currPos > peg$maxFailPos) {
        peg$maxFailPos = peg$currPos;
        peg$maxFailExpected = [];
      }

      peg$maxFailExpected.push(expected);
    }

    function peg$buildException(message, expected, found, location) {
      function cleanupExpected(expected) {
        var i = 1;
        expected.sort(function (a, b) {
          if (a.description < b.description) {
            return -1;
          } else if (a.description > b.description) {
            return 1;
          } else {
            return 0;
          }
        });

        while (i < expected.length) {
          if (expected[i - 1] === expected[i]) {
            expected.splice(i, 1);
          } else {
            i++;
          }
        }
      }

      function buildMessage(expected, found) {
        function stringEscape(s) {
          function hex(ch) {
            return ch.charCodeAt(0).toString(16).toUpperCase();
          }

          return s.replace(/\\/g, '\\\\').replace(/"/g, '\\"').replace(/\x08/g, '\\b').replace(/\t/g, '\\t').replace(/\n/g, '\\n').replace(/\f/g, '\\f').replace(/\r/g, '\\r').replace(/[\x00-\x07\x0B\x0E\x0F]/g, function (ch) {
            return '\\x0' + hex(ch);
          }).replace(/[\x10-\x1F\x80-\xFF]/g, function (ch) {
            return '\\x' + hex(ch);
          }).replace(/[\u0100-\u0FFF]/g, function (ch) {
            return '\\u0' + hex(ch);
          }).replace(/[\u1000-\uFFFF]/g, function (ch) {
            return '\\u' + hex(ch);
          });
        }

        var expectedDescs = new Array(expected.length),
            expectedDesc,
            foundDesc,
            i;

        for (i = 0; i < expected.length; i++) {
          expectedDescs[i] = expected[i].description;
        }

        expectedDesc = expected.length > 1 ? expectedDescs.slice(0, -1).join(", ") + " or " + expectedDescs[expected.length - 1] : expectedDescs[0];
        foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";
        return "Expected " + expectedDesc + " but " + foundDesc + " found.";
      }

      if (expected !== null) {
        cleanupExpected(expected);
      }

      return new peg$SyntaxError(message !== null ? message : buildMessage(expected, found), expected, found, location);
    }

    function peg$parsestart() {
      var s0, s1, s2, s3;
      var key = peg$currPos * 37 + 0,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = [];
      s2 = peg$parseSpace();

      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$parseSpace();
      }

      if (s1 !== peg$FAILED) {
        s2 = peg$parseOrQuery();

        if (s2 === peg$FAILED) {
          s2 = null;
        }

        if (s2 !== peg$FAILED) {
          s3 = peg$parseOptionalSpace();

          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c0(s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseOrQuery() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 1,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseAndQuery();

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parseOr();

        if (s4 !== peg$FAILED) {
          s5 = peg$parseAndQuery();

          if (s5 !== peg$FAILED) {
            peg$savedPos = s3;
            s4 = peg$c1(s1, s5);
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }

        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            s4 = peg$parseOr();

            if (s4 !== peg$FAILED) {
              s5 = peg$parseAndQuery();

              if (s5 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c1(s1, s5);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          }
        } else {
          s2 = peg$FAILED;
        }

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c2(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseAndQuery();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseAndQuery() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 2,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseNotQuery();

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parseAnd();

        if (s4 !== peg$FAILED) {
          s5 = peg$parseNotQuery();

          if (s5 !== peg$FAILED) {
            peg$savedPos = s3;
            s4 = peg$c1(s1, s5);
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }

        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            s4 = peg$parseAnd();

            if (s4 !== peg$FAILED) {
              s5 = peg$parseNotQuery();

              if (s5 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c1(s1, s5);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          }
        } else {
          s2 = peg$FAILED;
        }

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c3(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseNotQuery();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseNotQuery() {
      var s0, s1, s2;
      var key = peg$currPos * 37 + 3,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseNot();

      if (s1 !== peg$FAILED) {
        s2 = peg$parseSubQuery();

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c4(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseSubQuery();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseSubQuery() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 4,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c5;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c6);
        }
      }

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseSpace();

        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseSpace();
        }

        if (s2 !== peg$FAILED) {
          s3 = peg$parseOrQuery();

          if (s3 !== peg$FAILED) {
            s4 = peg$parseOptionalSpace();

            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 41) {
                s5 = peg$c7;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;

                if (peg$silentFails === 0) {
                  peg$fail(peg$c8);
                }
              }

              if (s5 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c9(s3, s4);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseNestedQuery();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseNestedQuery() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
      var key = peg$currPos * 37 + 5,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseField();

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseSpace();

        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseSpace();
        }

        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 58) {
            s3 = peg$c10;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c11);
            }
          }

          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parseSpace();

            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parseSpace();
            }

            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 123) {
                s5 = peg$c12;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;

                if (peg$silentFails === 0) {
                  peg$fail(peg$c13);
                }
              }

              if (s5 !== peg$FAILED) {
                s6 = [];
                s7 = peg$parseSpace();

                while (s7 !== peg$FAILED) {
                  s6.push(s7);
                  s7 = peg$parseSpace();
                }

                if (s6 !== peg$FAILED) {
                  s7 = peg$parseOrQuery();

                  if (s7 !== peg$FAILED) {
                    s8 = peg$parseOptionalSpace();

                    if (s8 !== peg$FAILED) {
                      if (input.charCodeAt(peg$currPos) === 125) {
                        s9 = peg$c14;
                        peg$currPos++;
                      } else {
                        s9 = peg$FAILED;

                        if (peg$silentFails === 0) {
                          peg$fail(peg$c15);
                        }
                      }

                      if (s9 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c16(s1, s7, s8);
                        s0 = s1;
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseExpression();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseExpression() {
      var s0;
      var key = peg$currPos * 37 + 6,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseFieldRangeExpression();

      if (s0 === peg$FAILED) {
        s0 = peg$parseFieldValueExpression();

        if (s0 === peg$FAILED) {
          s0 = peg$parseValueExpression();
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseField() {
      var s0, s1;
      var key = peg$currPos * 37 + 7,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$parseLiteral();
      peg$silentFails--;

      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c17);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseFieldRangeExpression() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 8,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseField();

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseSpace();

        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseSpace();
        }

        if (s2 !== peg$FAILED) {
          s3 = peg$parseRangeOperator();

          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parseSpace();

            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parseSpace();
            }

            if (s4 !== peg$FAILED) {
              s5 = peg$parseLiteral();

              if (s5 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c18(s1, s3, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseFieldValueExpression() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 9,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseField();

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseSpace();

        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseSpace();
        }

        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 58) {
            s3 = peg$c10;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c11);
            }
          }

          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parseSpace();

            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parseSpace();
            }

            if (s4 !== peg$FAILED) {
              s5 = peg$parseListOfValues();

              if (s5 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c19(s1, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseValueExpression() {
      var s0, s1;
      var key = peg$currPos * 37 + 10,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseValue();

      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c20(s1);
      }

      s0 = s1;
      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseListOfValues() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 11,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c5;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c6);
        }
      }

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseSpace();

        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseSpace();
        }

        if (s2 !== peg$FAILED) {
          s3 = peg$parseOrListOfValues();

          if (s3 !== peg$FAILED) {
            s4 = peg$parseOptionalSpace();

            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 41) {
                s5 = peg$c7;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;

                if (peg$silentFails === 0) {
                  peg$fail(peg$c8);
                }
              }

              if (s5 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c21(s3, s4);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseValue();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseOrListOfValues() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 12,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseAndListOfValues();

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parseOr();

        if (s4 !== peg$FAILED) {
          s5 = peg$parseAndListOfValues();

          if (s5 !== peg$FAILED) {
            peg$savedPos = s3;
            s4 = peg$c22(s1, s5);
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }

        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            s4 = peg$parseOr();

            if (s4 !== peg$FAILED) {
              s5 = peg$parseAndListOfValues();

              if (s5 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c22(s1, s5);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          }
        } else {
          s2 = peg$FAILED;
        }

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c23(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseAndListOfValues();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseAndListOfValues() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 13,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseNotListOfValues();

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parseAnd();

        if (s4 !== peg$FAILED) {
          s5 = peg$parseNotListOfValues();

          if (s5 !== peg$FAILED) {
            peg$savedPos = s3;
            s4 = peg$c22(s1, s5);
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }

        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            s4 = peg$parseAnd();

            if (s4 !== peg$FAILED) {
              s5 = peg$parseNotListOfValues();

              if (s5 !== peg$FAILED) {
                peg$savedPos = s3;
                s4 = peg$c22(s1, s5);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          }
        } else {
          s2 = peg$FAILED;
        }

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c24(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseNotListOfValues();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseNotListOfValues() {
      var s0, s1, s2;
      var key = peg$currPos * 37 + 14,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseNot();

      if (s1 !== peg$FAILED) {
        s2 = peg$parseListOfValues();

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c25(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$parseListOfValues();
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseValue() {
      var s0, s1;
      var key = peg$currPos * 37 + 15,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$parseQuotedString();

      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c27(s1);
      }

      s0 = s1;

      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseUnquotedLiteral();

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c28(s1);
        }

        s0 = s1;
      }

      peg$silentFails--;

      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c26);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseOr() {
      var s0, s1, s2, s3, s4;
      var key = peg$currPos * 37 + 16,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = [];
      s2 = peg$parseSpace();

      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          s2 = peg$parseSpace();
        }
      } else {
        s1 = peg$FAILED;
      }

      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2).toLowerCase() === peg$c30) {
          s2 = input.substr(peg$currPos, 2);
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c31);
          }
        }

        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseSpace();

          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseSpace();
            }
          } else {
            s3 = peg$FAILED;
          }

          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$silentFails--;

      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c29);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseAnd() {
      var s0, s1, s2, s3, s4;
      var key = peg$currPos * 37 + 17,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = [];
      s2 = peg$parseSpace();

      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          s2 = peg$parseSpace();
        }
      } else {
        s1 = peg$FAILED;
      }

      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 3).toLowerCase() === peg$c33) {
          s2 = input.substr(peg$currPos, 3);
          peg$currPos += 3;
        } else {
          s2 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c34);
          }
        }

        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseSpace();

          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseSpace();
            }
          } else {
            s3 = peg$FAILED;
          }

          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$silentFails--;

      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c32);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseNot() {
      var s0, s1, s2, s3;
      var key = peg$currPos * 37 + 18,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;

      if (input.substr(peg$currPos, 3).toLowerCase() === peg$c36) {
        s1 = input.substr(peg$currPos, 3);
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c37);
        }
      }

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseSpace();

        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseSpace();
          }
        } else {
          s2 = peg$FAILED;
        }

        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$silentFails--;

      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c35);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseLiteral() {
      var s0, s1;
      var key = peg$currPos * 37 + 19,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$parseQuotedString();

      if (s0 === peg$FAILED) {
        s0 = peg$parseUnquotedLiteral();
      }

      peg$silentFails--;

      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c38);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseQuotedString() {
      var s0, s1, s2, s3, s4, s5, s6;
      var key = peg$currPos * 37 + 20,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      peg$savedPos = peg$currPos;
      s1 = peg$c39();

      if (s1) {
        s1 = void 0;
      } else {
        s1 = peg$FAILED;
      }

      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 34) {
          s2 = peg$c40;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c41);
          }
        }

        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseQuotedCharacter();

          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$parseQuotedCharacter();
          }

          if (s3 !== peg$FAILED) {
            s4 = peg$parseCursor();

            if (s4 !== peg$FAILED) {
              s5 = [];
              s6 = peg$parseQuotedCharacter();

              while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$parseQuotedCharacter();
              }

              if (s5 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 34) {
                  s6 = peg$c40;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;

                  if (peg$silentFails === 0) {
                    peg$fail(peg$c41);
                  }
                }

                if (s6 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c42(s3, s4, s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$currPos;

        if (input.charCodeAt(peg$currPos) === 34) {
          s1 = peg$c40;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c41);
          }
        }

        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$parseQuotedCharacter();

          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseQuotedCharacter();
          }

          if (s2 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 34) {
              s3 = peg$c40;
              peg$currPos++;
            } else {
              s3 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c41);
              }
            }

            if (s3 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c43(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseQuotedCharacter() {
      var s0, s1, s2;
      var key = peg$currPos * 37 + 21,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseEscapedWhitespace();

      if (s0 === peg$FAILED) {
        s0 = peg$parseEscapedUnicodeSequence();

        if (s0 === peg$FAILED) {
          s0 = peg$currPos;

          if (input.charCodeAt(peg$currPos) === 92) {
            s1 = peg$c44;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c45);
            }
          }

          if (s1 !== peg$FAILED) {
            if (peg$c46.test(input.charAt(peg$currPos))) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c47);
              }
            }

            if (s2 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c48(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }

          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$currPos;
            peg$silentFails++;
            s2 = peg$parseCursor();
            peg$silentFails--;

            if (s2 === peg$FAILED) {
              s1 = void 0;
            } else {
              peg$currPos = s1;
              s1 = peg$FAILED;
            }

            if (s1 !== peg$FAILED) {
              if (peg$c49.test(input.charAt(peg$currPos))) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s2 = peg$FAILED;

                if (peg$silentFails === 0) {
                  peg$fail(peg$c50);
                }
              }

              if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c48(s2);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          }
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseUnquotedLiteral() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 22,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      peg$savedPos = peg$currPos;
      s1 = peg$c39();

      if (s1) {
        s1 = void 0;
      } else {
        s1 = peg$FAILED;
      }

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseUnquotedCharacter();

        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseUnquotedCharacter();
        }

        if (s2 !== peg$FAILED) {
          s3 = peg$parseCursor();

          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parseUnquotedCharacter();

            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parseUnquotedCharacter();
            }

            if (s4 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c42(s2, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parseUnquotedCharacter();

        if (s2 !== peg$FAILED) {
          while (s2 !== peg$FAILED) {
            s1.push(s2);
            s2 = peg$parseUnquotedCharacter();
          }
        } else {
          s1 = peg$FAILED;
        }

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c51(s1);
        }

        s0 = s1;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseUnquotedCharacter() {
      var s0, s1, s2, s3, s4;
      var key = peg$currPos * 37 + 23,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseEscapedWhitespace();

      if (s0 === peg$FAILED) {
        s0 = peg$parseEscapedSpecialCharacter();

        if (s0 === peg$FAILED) {
          s0 = peg$parseEscapedUnicodeSequence();

          if (s0 === peg$FAILED) {
            s0 = peg$parseEscapedKeyword();

            if (s0 === peg$FAILED) {
              s0 = peg$parseWildcard();

              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$currPos;
                peg$silentFails++;
                s2 = peg$parseSpecialCharacter();
                peg$silentFails--;

                if (s2 === peg$FAILED) {
                  s1 = void 0;
                } else {
                  peg$currPos = s1;
                  s1 = peg$FAILED;
                }

                if (s1 !== peg$FAILED) {
                  s2 = peg$currPos;
                  peg$silentFails++;
                  s3 = peg$parseKeyword();
                  peg$silentFails--;

                  if (s3 === peg$FAILED) {
                    s2 = void 0;
                  } else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                  }

                  if (s2 !== peg$FAILED) {
                    s3 = peg$currPos;
                    peg$silentFails++;
                    s4 = peg$parseCursor();
                    peg$silentFails--;

                    if (s4 === peg$FAILED) {
                      s3 = void 0;
                    } else {
                      peg$currPos = s3;
                      s3 = peg$FAILED;
                    }

                    if (s3 !== peg$FAILED) {
                      if (input.length > peg$currPos) {
                        s4 = input.charAt(peg$currPos);
                        peg$currPos++;
                      } else {
                        s4 = peg$FAILED;

                        if (peg$silentFails === 0) {
                          peg$fail(peg$c52);
                        }
                      }

                      if (s4 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c48(s4);
                        s0 = s1;
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              }
            }
          }
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseWildcard() {
      var s0, s1;
      var key = peg$currPos * 37 + 24,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.charCodeAt(peg$currPos) === 42) {
        s1 = peg$c53;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c54);
        }
      }

      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c55();
      }

      s0 = s1;
      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseOptionalSpace() {
      var s0, s1, s2, s3, s4, s5;
      var key = peg$currPos * 37 + 25,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      peg$savedPos = peg$currPos;
      s1 = peg$c39();

      if (s1) {
        s1 = void 0;
      } else {
        s1 = peg$FAILED;
      }

      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseSpace();

        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseSpace();
        }

        if (s2 !== peg$FAILED) {
          s3 = peg$parseCursor();

          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parseSpace();

            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parseSpace();
            }

            if (s4 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c42(s2, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      if (s0 === peg$FAILED) {
        s0 = [];
        s1 = peg$parseSpace();

        while (s1 !== peg$FAILED) {
          s0.push(s1);
          s1 = peg$parseSpace();
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseEscapedWhitespace() {
      var s0, s1;
      var key = peg$currPos * 37 + 26,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.substr(peg$currPos, 2) === peg$c56) {
        s1 = peg$c56;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c57);
        }
      }

      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c58();
      }

      s0 = s1;

      if (s0 === peg$FAILED) {
        s0 = peg$currPos;

        if (input.substr(peg$currPos, 2) === peg$c59) {
          s1 = peg$c59;
          peg$currPos += 2;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c60);
          }
        }

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c61();
        }

        s0 = s1;

        if (s0 === peg$FAILED) {
          s0 = peg$currPos;

          if (input.substr(peg$currPos, 2) === peg$c62) {
            s1 = peg$c62;
            peg$currPos += 2;
          } else {
            s1 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c63);
            }
          }

          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c64();
          }

          s0 = s1;
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseEscapedSpecialCharacter() {
      var s0, s1, s2;
      var key = peg$currPos * 37 + 27,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.charCodeAt(peg$currPos) === 92) {
        s1 = peg$c44;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c45);
        }
      }

      if (s1 !== peg$FAILED) {
        s2 = peg$parseSpecialCharacter();

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c48(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseEscapedKeyword() {
      var s0, s1, s2;
      var key = peg$currPos * 37 + 28,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.charCodeAt(peg$currPos) === 92) {
        s1 = peg$c44;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c45);
        }
      }

      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2).toLowerCase() === peg$c30) {
          s2 = input.substr(peg$currPos, 2);
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c31);
          }
        }

        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 3).toLowerCase() === peg$c33) {
            s2 = input.substr(peg$currPos, 3);
            peg$currPos += 3;
          } else {
            s2 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c34);
            }
          }

          if (s2 === peg$FAILED) {
            if (input.substr(peg$currPos, 3).toLowerCase() === peg$c36) {
              s2 = input.substr(peg$currPos, 3);
              peg$currPos += 3;
            } else {
              s2 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c37);
              }
            }
          }
        }

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c65(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseKeyword() {
      var s0;
      var key = peg$currPos * 37 + 29,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseOr();

      if (s0 === peg$FAILED) {
        s0 = peg$parseAnd();

        if (s0 === peg$FAILED) {
          s0 = peg$parseNot();
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseSpecialCharacter() {
      var s0;
      var key = peg$currPos * 37 + 30,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c66.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c67);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseEscapedUnicodeSequence() {
      var s0, s1, s2;
      var key = peg$currPos * 37 + 31,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.charCodeAt(peg$currPos) === 92) {
        s1 = peg$c44;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c45);
        }
      }

      if (s1 !== peg$FAILED) {
        s2 = peg$parseUnicodeSequence();

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c68(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseUnicodeSequence() {
      var s0, s1, s2, s3, s4, s5, s6, s7;
      var key = peg$currPos * 37 + 32,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.charCodeAt(peg$currPos) === 117) {
        s1 = peg$c69;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c70);
        }
      }

      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        s3 = peg$currPos;
        s4 = peg$parseHexDigit();

        if (s4 !== peg$FAILED) {
          s5 = peg$parseHexDigit();

          if (s5 !== peg$FAILED) {
            s6 = peg$parseHexDigit();

            if (s6 !== peg$FAILED) {
              s7 = peg$parseHexDigit();

              if (s7 !== peg$FAILED) {
                s4 = [s4, s5, s6, s7];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }

        if (s3 !== peg$FAILED) {
          s2 = input.substring(s2, peg$currPos);
        } else {
          s2 = s3;
        }

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c71(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseHexDigit() {
      var s0;
      var key = peg$currPos * 37 + 33,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c72.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c73);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseRangeOperator() {
      var s0, s1;
      var key = peg$currPos * 37 + 34,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;

      if (input.substr(peg$currPos, 2) === peg$c74) {
        s1 = peg$c74;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c75);
        }
      }

      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c76();
      }

      s0 = s1;

      if (s0 === peg$FAILED) {
        s0 = peg$currPos;

        if (input.substr(peg$currPos, 2) === peg$c77) {
          s1 = peg$c77;
          peg$currPos += 2;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c78);
          }
        }

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c79();
        }

        s0 = s1;

        if (s0 === peg$FAILED) {
          s0 = peg$currPos;

          if (input.charCodeAt(peg$currPos) === 60) {
            s1 = peg$c80;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c81);
            }
          }

          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c82();
          }

          s0 = s1;

          if (s0 === peg$FAILED) {
            s0 = peg$currPos;

            if (input.charCodeAt(peg$currPos) === 62) {
              s1 = peg$c83;
              peg$currPos++;
            } else {
              s1 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c84);
              }
            }

            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c85();
            }

            s0 = s1;
          }
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseSpace() {
      var s0, s1;
      var key = peg$currPos * 37 + 35,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;

      if (peg$c87.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c88);
        }
      }

      peg$silentFails--;

      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;

        if (peg$silentFails === 0) {
          peg$fail(peg$c86);
        }
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    function peg$parseCursor() {
      var s0, s1, s2;
      var key = peg$currPos * 37 + 36,
          cached = peg$resultsCache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      peg$savedPos = peg$currPos;
      s1 = peg$c39();

      if (s1) {
        s1 = void 0;
      } else {
        s1 = peg$FAILED;
      }

      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 14) === peg$c89) {
          s2 = peg$c89;
          peg$currPos += 14;
        } else {
          s2 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c90);
          }
        }

        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c91();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      peg$resultsCache[key] = {
        nextPos: peg$currPos,
        result: s0
      };
      return s0;
    }

    const {
      parseCursor,
      cursorSymbol,
      allowLeadingWildcards = true,
      helpers: {
        nodeTypes
      }
    } = options;
    const buildFunctionNode = nodeTypes.function.buildNodeWithArgumentNodes;
    const buildLiteralNode = nodeTypes.literal.buildNode;
    const buildWildcardNode = nodeTypes.wildcard.buildNode;
    const buildNamedArgNode = nodeTypes.namedArg.buildNode;
    const {
      wildcardSymbol
    } = nodeTypes.wildcard;
    peg$result = peg$startRuleFunction();

    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
      return peg$result;
    } else {
      if (peg$result !== peg$FAILED && peg$currPos < input.length) {
        peg$fail({
          type: "end",
          description: "end of input"
        });
      }

      throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null, peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos));
    }
  }

  return {
    SyntaxError: peg$SyntaxError,
    parse: peg$parse
  };
}();